//
//  OBL_alg.h
//  
//
//  Created by Lucas Angelo on 16/07/15.
//
//

#ifndef _OBL_alg_h
#define _OBL_alg_h
#include "structure.h"
#include "Calc_entropy.h"

void read_permutation_of_archivo(char* name, permutation *perm);


// Procedure that generates the initial population

void population_init(population *pob, permutation *perm);

//compute the distance to each genome of the population
void fitness_population(population *pob, int flag);

void countingSort(population *pob, int k);


void selection(population *pob,  int n_generetion, int * best_solution);


void crossover(population *pob, permutation *perm);

void mutation(population *pob, permutation *perm);


void replacement(population *pob);



/* Function that converts a genome into his opposite from "start" to "end"
 * Whenever it improves it fitness value
 */
int opposite_genome(population *pob, int i, int start, int end);




/* method that resert the population, conservando una parte
 * e gerando aleatoriamente oresto
 */
void restarting_population(population *pob, permutation *perm);



//this function return 1 for reset population and 0 otherwise
int reset_population(population *pob);

void see_population(permutation *perm,population *pob);


void see_fitness(population *pob ,int flag);



// Method that generates the opposites for all the population
void OBL(population *pob, int nro_generation);

void OBLGa(float probreset, float oposition, float probretation);







#endif
